package main

import (
	"fmt"
	"testing"
)

func TestGuild(t *testing.T) {
	guildMgr := NewGuildMgr()
	leaderID := "apple"
	memberID := "sony"

	guildID, err := guildMgr.CreateGuild("GuildWorld", leaderID, 10)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Created guild:", guildID)

	err = guildMgr.ApplyToGuild(guildID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Applied to guild")

	err = guildMgr.ApproveApplication(guildID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Approved application")

	err = guildMgr.JoinGuild(guildID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Joined guild")

	err = guildMgr.PromoteMember(guildID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Promoted member")

	err = guildMgr.LeaveGuild(guildID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Left guild")

	err = guildMgr.DismissMember(guildID, memberID, memberID)
	if err != nil {
		fmt.Println("Error:", err)
		return
	}
	fmt.Println("Dismissed member")

	fmt.Println("Guild logs:", guildMgr.Logs)
}
